/*
 * Copyright: JessMA Open Source (ldcsaa@gmail.com)
 *
 * Version	: 3.3.1
 * Author	: Bruce Liang
 * Website	: http://www.jessma.org
 * Project	: https://github.com/ldcsaa
 * Blog		: http://www.cnblogs.com/ldcsaa
 * Wiki		: http://www.oschina.net/p/hp-socket
 * QQ Group	: 75375912
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
 
#pragma once

#include <winsock2.h>

/************************************************************************
ƣ ID 
Ӧó԰ CONNID ΪҪͣ磺ULONG / ULONGLONG
************************************************************************/
typedef ULONG_PTR	CONNID;

/*****************************************************************************************************/
/******************************************** ࡢӿ ********************************************/
/*****************************************************************************************************/

/************************************************************************
ƣͨ״̬
Ӧóͨͨ GetState() ȡǰ״̬
************************************************************************/
enum EnServiceState
{
	SS_STARTING	= 0,	// 
	SS_STARTED	= 1,	// Ѿ
	SS_STOPPING	= 2,	// ֹͣ
	SS_STOPPED	= 3,	// Ѿֹͣ
};

/************************************************************************
ƣSocket 
Ӧó OnErrror() ¼ͨòʶֲµĴ
************************************************************************/
enum EnSocketOperation
{
	SO_UNKNOWN	= 0,	// Unknown
	SO_ACCEPT	= 1,	// Acccept
	SO_CONNECT	= 2,	// Connect
	SO_SEND		= 3,	// Send
	SO_RECEIVE	= 4,	// Receive
};

/************************************************************************
ƣ¼
¼ķֵͬķֵӰͨĺΪ
************************************************************************/
enum EnHandleResult
{
	HR_OK		= 0,	// ɹ
	HR_IGNORE	= 1,	// 
	HR_ERROR	= 2,	// 
};

/************************************************************************
ƣץȡ
ץȡķֵ
************************************************************************/
enum EnFetchResult
{
	FR_OK				= 0,	// ɹ
	FR_LENGTH_TOO_LONG	= 1,	// ץȡȹ
	FR_DATA_NOT_FOUND	= 2,	// Ҳ ConnID Ӧ
};

/************************************************************************
ƣݷͲ
Server  Agent ݷͲ

* ģʽĬϣ	ѶͲһͣӴЧ
* ȫģʽ			ѶͲһͣƴٶȣ⻺
* ֱģʽ			ÿһͲֱͶݣڸزߵҪʵʱԽϸߵĳ

************************************************************************/
enum EnSendPolicy
{
	SP_PACK				= 0,	// ģʽĬϣ
	SP_SAFE				= 1,	// ȫģʽ
	SP_DIRECT			= 2,	// ֱģʽ
};

/************************************************************************
ƣݽղ
Server  Agent ݽղ

* ģʽĬϣ	ڵӣ˳򴥷 OnReceive  OnClose/OnError ¼
					  ӦóĸӶȣǿȫԣͬʱʧһЩܡ
* ģʽ			ڵӣͬʱյ OnReceive  OnClose/OnError ¼ʱ
					  ڲͬ ͨ߳ͬʱЩ¼ʹܵõӦó
					  Ҫ OnReceive ¼УĳЩܱ OnClose/OnError
					  ¼ĻͷŵΣ߼øӣʱȱ

************************************************************************/
enum EnRecvPolicy
{
	RP_SERIAL			= 0,	// ģʽĬϣ
	RP_PARALLEL			= 1,	// ģʽ
};

/************************************************************************
ƣ
 Start() / Stop() ִʧʱͨ GetLastError() ȡ
************************************************************************/
enum EnSocketError
{
	SE_OK						= NO_ERROR,	// ɹ
	SE_ILLEGAL_STATE			= 1,		// ǰ״̬
	SE_INVALID_PARAM			= 2,		// Ƿ
	SE_SOCKET_CREATE			= 3,		//  SOCKET ʧ
	SE_SOCKET_BIND				= 4,		//  SOCKET ʧ
	SE_SOCKET_PREPARE			= 5,		//  SOCKET ʧ
	SE_SOCKET_LISTEN			= 6,		//  SOCKET ʧ
	SE_CP_CREATE				= 7,		// ɶ˿ʧ
	SE_WORKER_THREAD_CREATE		= 8,		// ߳ʧ
	SE_DETECT_THREAD_CREATE		= 9,		// ߳ʧ
	SE_SOCKE_ATTACH_TO_CP		= 10,		// ɶ˿ʧ
	SE_CONNECT_SERVER			= 11,		// ӷʧ
	SE_NETWORK					= 12,		// 
	SE_DATA_PROC				= 13,		// ݴ
	SE_DATA_SEND				= 14,		// ݷʧ
};

/************************************************************************
ƣģʽ
UDP Ĳģʽ鲥㲥
************************************************************************/
enum EnCastMode
{
	CM_MULTICAST	= 0,	// 鲥
	CM_BROADCAST	= 1,	// 㲥
};

/************************************************************************
ƣSocket ӿ
˺Ϳͻ Socket ĹϢ
************************************************************************/
class IComplexSocketListener
{
public:

	/*
	* ƣѷ֪ͨ
	* ɹݺSocket յ֪ͨ
	*		
	* 		dwConnID	--  ID
	*			pData		-- ѷݻ
	*			iLength		-- ѷݳ
	* ֵ	HR_OK / HR_IGNORE	-- ִ
	*			HR_ERROR			-- ֪ͨ HR_ERRORģʽԴ
	*/
	virtual EnHandleResult OnSend(CONNID dwConnID, const BYTE* pData, int iLength)					= 0;

	/*
	* ƣݵ֪ͨPUSH ģͣ
	*  PUSH ģ͵ Socket ͨɹݺ Socket ͸֪ͨ
	*		
	* 		dwConnID	--  ID
	*			pData		-- ѽݻ
	*			iLength		-- ѽݳ
	* ֵ	HR_OK / HR_IGNORE	-- ִ
	*			HR_ERROR			--  OnError() ¼ʱ䲢ر
	*/
	virtual EnHandleResult OnReceive(CONNID dwConnID, const BYTE* pData, int iLength)				= 0;

	/*
	* ƣݵ֪ͨPULL ģͣ
	*  PULL ģ͵ Socket ͨɹݺ Socket ͸֪ͨ
	*		
	* 		dwConnID	--  ID
	*			iLength		-- ѽݳ
	* ֵ	HR_OK / HR_IGNORE	-- ִ
	*			HR_ERROR			--  OnError() ¼ʱ䲢ر
	*/
	virtual EnHandleResult OnReceive(CONNID dwConnID, int iLength)									= 0;

	/*
	* ƣѹر֪ͨ
	* رӺSocket յ֪ͨ
	*		
	* 		dwConnID --  ID
	* ֵ	Էֵ
	*/
	virtual EnHandleResult OnClose(CONNID dwConnID)													= 0;

	/*
	* ƣͨŴ֪ͨ
	* ͨŷSocket յ֪ͨر
	*		
	* 		dwConnID	--  ID
	*			enOperation	-- Socket 
	*			iErrorCode	-- 
	* ֵ	Էֵ
	*/
	virtual EnHandleResult OnError(CONNID dwConnID, EnSocketOperation enOperation, int iErrorCode)	= 0;

	/*
	* ƣر֪ͨͨ
	* ͨرʱSocket յ֪ͨ
	*		
	* 	
	* ֵԷֵ
	*/
	virtual EnHandleResult OnShutdown()																= 0;

public:
	virtual ~IComplexSocketListener() {}
};

/************************************************************************
ƣ Socket ӿ
 Socket ¼
************************************************************************/
class IServerListener : public IComplexSocketListener
{
public:

	/*
	* ƣ׼֪ͨ
	* ͨŷʱڼ Socket ɲʼִмǰSocket 
	*		յִ֪֪ͨͨ Socket ѡõȶ⹤
	*		
	* 		soListen	--  Socket
	* ֵ	HR_OK / HR_IGNORE	-- ִ
	*			HR_ERROR			-- ֹͨŷ
	*/
	virtual EnHandleResult OnPrepareListen(SOCKET soListen)				= 0;
};

/************************************************************************
ƣTCP  Socket ӿ
 TCP  Socket ¼
************************************************************************/
class ITcpServerListener : public IServerListener
{
public:

	/*
	* ƣ֪ͨ
	* յͻʱSocket յ֪֪ͨͨ
	*		ִ Socket ѡûܾͻӵȶ⹤
	*		
	* 		dwConnID	--  ID
	*			soClient	-- ͻ Socket
	* ֵ	HR_OK / HR_IGNORE	-- 
	*			HR_ERROR			-- ܾ
	*/
	virtual EnHandleResult OnAccept(CONNID dwConnID, SOCKET soClient)	= 0;
};

/************************************************************************
ƣPUSH ģͷ Socket 
ĳЩ¼Ĭϴ¼
************************************************************************/
class CTcpServerListener : public ITcpServerListener
{
public:
	virtual EnHandleResult OnReceive(CONNID dwConnID, int iLength)					{return HR_IGNORE;}
	virtual EnHandleResult OnSend(CONNID dwConnID, const BYTE* pData, int iLength)	{return HR_IGNORE;}
	virtual EnHandleResult OnPrepareListen(SOCKET soListen)							{return HR_IGNORE;}
	virtual EnHandleResult OnAccept(CONNID dwConnID, SOCKET soClient)				{return HR_IGNORE;}
	virtual EnHandleResult OnShutdown()												{return HR_IGNORE;}
};

/************************************************************************
ƣPULL ģͷ Socket 
ĳЩ¼Ĭϴ¼
************************************************************************/
class CTcpPullServerListener : public CTcpServerListener
{
public:
	virtual EnHandleResult OnReceive(CONNID dwConnID, int iLength)						= 0;
	virtual EnHandleResult OnReceive(CONNID dwConnID, const BYTE* pData, int iLength)	{return HR_IGNORE;}
};

/************************************************************************
ƣUDP  Socket ӿ
 UDP  Socket ¼
************************************************************************/
class IUdpServerListener : public IServerListener
{
public:

	/*
	* ƣ֪ͨ
	* յͻʱSocket յ֪֪ͨͨ
	*		ִ Socket ѡûܾͻӵȶ⹤
	*		
	* 		dwConnID	--  ID
	*			soClient	-- ͻ Socket
	* ֵ	HR_OK / HR_IGNORE	-- 
	*			HR_ERROR			-- ܾ
	*/
	virtual EnHandleResult OnAccept(CONNID dwConnID, const SOCKADDR_IN* pSockAddr)	= 0;
};

/************************************************************************
ƣUDP  Socket 
ĳЩ¼Ĭϴ¼
************************************************************************/
class CUdpServerListener : public IUdpServerListener
{
public:
	virtual EnHandleResult OnReceive(CONNID dwConnID, int iLength)					{return HR_IGNORE;}
	virtual EnHandleResult OnSend(CONNID dwConnID, const BYTE* pData, int iLength)	{return HR_IGNORE;}
	virtual EnHandleResult OnPrepareListen(SOCKET soListen)							{return HR_IGNORE;}
	virtual EnHandleResult OnAccept(CONNID dwConnID, const SOCKADDR_IN* pSockAddr)	{return HR_IGNORE;}
	virtual EnHandleResult OnShutdown()												{return HR_IGNORE;}
};

/************************************************************************
ƣͨŴ Socket ӿ
 ͨŴ Socket ¼
************************************************************************/
class IAgentListener : public IComplexSocketListener
{
public:

	/*
	* ƣ׼֪ͨ
	* ͨſͻʱڿͻ Socket ɲʼִǰSocket 
	*		յִ֪֪ͨͨ Socket ѡõȶ⹤
	*		
	* 		dwConnID	--  ID
	*			socket		-- ͻ Socket
	* ֵ	HR_OK / HR_IGNORE	-- ִ
	*			HR_ERROR			-- ֹͨſͻ
	*/
	virtual EnHandleResult OnPrepareConnect(CONNID dwConnID, SOCKET socket)		= 0;

	/*
	* ƣ֪ͨ
	* ˳ɹʱSocket յ֪ͨ
	*		
	* 		dwConnID	--  ID
	* ֵ	HR_OK / HR_IGNORE	-- ִ
	*			HR_ERROR			-- ͬӣֹͨſͻ
	*								   첽ӣر
	*/
	virtual EnHandleResult OnConnect(CONNID dwConnID)							= 0;
};

/************************************************************************
ƣTCP ͨŴ Socket ӿ
 TCP ͨŴ Socket ¼
************************************************************************/
class ITcpAgentListener : public IAgentListener
{
};

/************************************************************************
ƣPUSH ģͨŴ Socket 
ĳЩ¼Ĭϴ¼
************************************************************************/
class CTcpAgentListener : public ITcpAgentListener
{
public:
	virtual EnHandleResult OnReceive(CONNID dwConnID, int iLength)						{return HR_IGNORE;}
	virtual EnHandleResult OnSend(CONNID dwConnID, const BYTE* pData, int iLength)		{return HR_IGNORE;}
	virtual EnHandleResult OnPrepareConnect(CONNID dwConnID, SOCKET socket)				{return HR_IGNORE;}
	virtual EnHandleResult OnConnect(CONNID dwConnID)									{return HR_IGNORE;}
	virtual EnHandleResult OnShutdown()													{return HR_IGNORE;}
};

/************************************************************************
ƣPULL ͨŴ Socket 
ĳЩ¼Ĭϴ¼
************************************************************************/
class CTcpPullAgentListener : public CTcpAgentListener
{
public:
	virtual EnHandleResult OnReceive(CONNID dwConnID, int iLength)						= 0;
	virtual EnHandleResult OnReceive(CONNID dwConnID, const BYTE* pData, int iLength)	{return HR_IGNORE;}
};

class IClient;

/************************************************************************
ƣͻ Socket ӿ
ͻ Socket ¼
************************************************************************/
class IClientListener
{
public:

	/*
	* ƣ׼֪ͨ
	* ͨſͻʱڿͻ Socket ɲʼִǰSocket 
	*		յִ֪֪ͨͨ Socket ѡõȶ⹤
	*		
	* 		dwConnID	--  ID
	*			socket		-- ͻ Socket
	* ֵ	HR_OK / HR_IGNORE	-- ִ
	*			HR_ERROR			-- ֹͨſͻ
	*/
	virtual EnHandleResult OnPrepareConnect(IClient* pClient, SOCKET socket)						= 0;

	/*
	* ƣ֪ͨ
	* ˳ɹʱSocket յ֪ͨ
	*		
	* 		dwConnID	--  ID
	* ֵ	HR_OK / HR_IGNORE	-- ִ
	*			HR_ERROR			-- ͬӣֹͨſͻ
	*								   첽ӣر
	*/
	virtual EnHandleResult OnConnect(IClient* pClient)												= 0;

	/*
	* ƣѷ֪ͨ
	* ɹݺSocket յ֪ͨ
	*		
	* 		dwConnID	--  ID
	*			pData		-- ѷݻ
	*			iLength		-- ѷݳ
	* ֵ	HR_OK / HR_IGNORE	-- ִ
	*			HR_ERROR			-- ֪ͨ HR_ERRORģʽԴ
	*/
	virtual EnHandleResult OnSend(IClient* pClient, const BYTE* pData, int iLength)					= 0;

	/*
	* ƣݵ֪ͨPUSH ģͣ
	*  PUSH ģ͵ Socket ͨɹݺ Socket ͸֪ͨ
	*		
	* 		dwConnID	--  ID
	*			pData		-- ѽݻ
	*			iLength		-- ѽݳ
	* ֵ	HR_OK / HR_IGNORE	-- ִ
	*			HR_ERROR			--  OnError() ¼ʱ䲢ر
	*/
	virtual EnHandleResult OnReceive(IClient* pClient, const BYTE* pData, int iLength)				= 0;

	/*
	* ƣݵ֪ͨPULL ģͣ
	*  PULL ģ͵ Socket ͨɹݺ Socket ͸֪ͨ
	*		
	* 		dwConnID	--  ID
	*			iLength		-- ѽݳ
	* ֵ	HR_OK / HR_IGNORE	-- ִ
	*			HR_ERROR			--  OnError() ¼ʱ䲢ر
	*/
	virtual EnHandleResult OnReceive(IClient* pClient, int iLength)									= 0;

	/*
	* ƣѹر֪ͨ
	* رӺSocket յ֪ͨ
	*		
	* 		dwConnID --  ID
	* ֵ	Էֵ
	*/
	virtual EnHandleResult OnClose(IClient* pClient)												= 0;

	/*
	* ƣͨŴ֪ͨ
	* ͨŷSocket յ֪ͨر
	*		
	* 		dwConnID	--  ID
	*			enOperation	-- Socket 
	*			iErrorCode	-- 
	* ֵ	Էֵ
	*/
	virtual EnHandleResult OnError(IClient* pClient, EnSocketOperation enOperation, int iErrorCode)	= 0;

public:
	virtual ~IClientListener() {}
};

/************************************************************************
ƣTCP ͻ Socket ӿ
 TCP ͻ Socket ¼
************************************************************************/
class ITcpClientListener : public IClientListener
{
};

/************************************************************************
ƣPUSH ģͿͻ Socket 
ĳЩ¼Ĭϴ¼
************************************************************************/
class CTcpClientListener : public ITcpClientListener
{
public:
	virtual EnHandleResult OnReceive(IClient* pClient, int iLength)						{return HR_IGNORE;}
	virtual EnHandleResult OnSend(IClient* pClient, const BYTE* pData, int iLength)		{return HR_IGNORE;}
	virtual EnHandleResult OnPrepareConnect(IClient* pClient, SOCKET socket)			{return HR_IGNORE;}
	virtual EnHandleResult OnConnect(IClient* pClient)									{return HR_IGNORE;}
};

/************************************************************************
ƣPULL ͻ Socket 
ĳЩ¼Ĭϴ¼
************************************************************************/
class CTcpPullClientListener : public CTcpClientListener
{
public:
	virtual EnHandleResult OnReceive(IClient* pClient, int iLength)						= 0;
	virtual EnHandleResult OnReceive(IClient* pClient, const BYTE* pData, int iLength)	{return HR_IGNORE;}
};

/************************************************************************
ƣUDP ͻ Socket ӿ
 UDP ͻ Socket ¼
************************************************************************/
class IUdpClientListener : public IClientListener
{
};

/************************************************************************
ƣUDP  Socket 
ĳЩ¼Ĭϴ¼
************************************************************************/
class CUdpClientListener : public IUdpClientListener
{
public:
	virtual EnHandleResult OnReceive(IClient* pClient, int iLength)						{return HR_IGNORE;}
	virtual EnHandleResult OnSend(IClient* pClient, const BYTE* pData, int iLength)		{return HR_IGNORE;}
	virtual EnHandleResult OnPrepareConnect(IClient* pClient, SOCKET socket)			{return HR_IGNORE;}
	virtual EnHandleResult OnConnect(IClient* pClient)									{return HR_IGNORE;}
};

/************************************************************************
ƣUDP  Socket ӿ
 UDP  Socket ¼
************************************************************************/
class IUdpCastListener : public IClientListener
{
};

/************************************************************************
ƣUDP  Socket 
ĳЩ¼Ĭϴ¼
************************************************************************/
class CUdpCastListener : public IUdpCastListener
{
public:
	virtual EnHandleResult OnReceive(IClient* pClient, int iLength)						{return HR_IGNORE;}
	virtual EnHandleResult OnSend(IClient* pClient, const BYTE* pData, int iLength)		{return HR_IGNORE;}
	virtual EnHandleResult OnPrepareConnect(IClient* pClient, SOCKET socket)			{return HR_IGNORE;}
	virtual EnHandleResult OnConnect(IClient* pClient)									{return HR_IGNORE;}
};

/************************************************************************
ƣ Socket ӿ
帴 Socket вԷʷ Socket ͬʱ Socket 
************************************************************************/
class IComplexSocket
{
public:

	/***********************************************************************/
	/*****************************  *****************************/

	/*
	* ƣرͨ
	* رͨرɺϿӲͷԴ
	*		
	* 	
	* ֵ	TRUE	-- ɹ
	*			FALSE	-- ʧܣͨ GetLastError() ȡ
	*/
	virtual BOOL Stop	()																		= 0;

	/*
	* ƣ
	* ָӷ
	*		
	* 		dwConnID	--  ID
	*			pBuffer		-- ͻ
	*			iLength		-- ͻ
	*			iOffset		-- ͻָƫ
	* ֵ	TRUE	-- ɹ
	*			FALSE	-- ʧܣͨ Windows API  ::GetLastError() ȡ Windows 
	*/
	virtual BOOL Send	(CONNID dwConnID, const BYTE* pBuffer, int iLength, int iOffset = 0)	= 0;

	/*
	* ƣͶ
	* ָӷͶ
	*		TCP - ˳ݰ 
	*		UDP - ݰϳһݰͣݰܳȲܴõ UDP 󳤶ȣ 
	*		
	* 		dwConnID	--  ID
	*			pBuffers	-- ͻ
	*			iCount		-- ͻĿ
	* ֵ	TRUE	-- ɹ
	*			FALSE	-- ʧܣͨ Windows API  ::GetLastError() ȡ Windows 
	*/
	virtual BOOL SendPackets(CONNID dwConnID, const WSABUF pBuffers[], int iCount)	= 0;

	/*
	* ƣϿ
	* Ͽĳ
	*		
	* 		dwConnID	--  ID
	*			bForce		-- ǷǿƶϿ
	* ֵ	TRUE	-- ɹ
	*			FALSE	-- ʧ
	*/
	virtual BOOL Disconnect(CONNID dwConnID, BOOL bForce = TRUE)					= 0;

	/*
	* ƣϿʱ
	* Ͽָʱ
	*		
	* 		dwPeriod	-- ʱ룩
	*			bForce		-- ǷǿƶϿ
	* ֵ	TRUE	-- ɹ
	*			FALSE	-- ʧ
	*/
	virtual BOOL DisconnectLongConnections(DWORD dwPeriod, BOOL bForce = TRUE)		= 0;

	/*
	* ƣϿĬ
	* ϿָʱľĬ
	*		
	* 		dwPeriod	-- ʱ룩
	*			bForce		-- ǷǿƶϿ
	* ֵ	TRUE	-- ɹ
	*			FALSE	-- ʧ
	*/
	virtual BOOL DisconnectSilenceConnections(DWORD dwPeriod, BOOL bForce = TRUE)	= 0;

public:

	/***********************************************************************/
	/***************************** Էʷ *****************************/

	/*
	* ƣӵĸ
	* ǷΪӰ󶨸ݻ߰ʲôݣӦó
	*		
	* 		dwConnID	--  ID
	*			pv			-- 
	* ֵ	TRUE	-- ɹ
	*			FALSE	-- ʧܣЧ ID
	*/
	virtual BOOL SetConnectionExtra		(CONNID dwConnID, PVOID pExtra)			= 0;

	/*
	* ƣȡӵĸ
	* ǷΪӰ󶨸ݻ߰ʲôݣӦó
	*		
	* 		dwConnID	--  ID
	*			ppv			-- ָ
	* ֵ	TRUE	-- ɹ
	*			FALSE	-- ʧܣЧ ID
	*/
	virtual BOOL GetConnectionExtra			(CONNID dwConnID, PVOID* ppExtra)	= 0;

	/* ͨǷ */
	virtual BOOL HasStarted				()									= 0;
	/* 鿴ͨǰ״̬ */
	virtual EnServiceState GetState		()									= 0;
	/* ȡ */
	virtual DWORD GetConnectionCount	()									= 0;
	/* ȡӵ CONNID */
	virtual BOOL GetAllConnectionIDs	(CONNID pIDs[], DWORD& dwCount)		= 0;
	/* ȡĳʱ룩 */
	virtual BOOL GetConnectPeriod		(CONNID dwConnID, DWORD& dwPeriod)	= 0;
	/* ȡĳӾĬʱ䣨룩 */
	virtual BOOL GetSilencePeriod		(CONNID dwConnID, DWORD& dwPeriod)	= 0;
	/* ȡĳӵԶ̵ַϢ */
	virtual BOOL GetRemoteAddress		(CONNID dwConnID, TCHAR lpszAddress[], int& iAddressLen, USHORT& usPort)	= 0;
	/* ȡһʧܲĴ */
	virtual EnSocketError GetLastError	()									= 0;
	/* ȡһʧܲĴ */
	virtual LPCTSTR GetLastErrorDesc	()									= 0;
	/* ȡδݵĳ */
	virtual BOOL GetPendingDataLength	(CONNID dwConnID, int& iPending)	= 0;

	/* ݷͲ */
	virtual void SetSendPolicy				(EnSendPolicy enSendPolicy)		= 0;
	/* ݽղ */
	virtual void SetRecvPolicy				(EnRecvPolicy enRecvPolicy)		= 0;
	/*  Socket ʱ䣨룬ڼ Socket ܱȡʹã */
	virtual void SetFreeSocketObjLockTime	(DWORD dwFreeSocketObjLockTime)	= 0;
	/*  Socket شСͨΪƽ 1/3 - 1/2 */
	virtual void SetFreeSocketObjPool		(DWORD dwFreeSocketObjPool)		= 0;
	/* ڴ黺شСͨΪ Socket شС 2 - 3  */
	virtual void SetFreeBufferObjPool		(DWORD dwFreeBufferObjPool)		= 0;
	/*  Socket ػշֵͨΪ Socket شС 3  */
	virtual void SetFreeSocketObjHold		(DWORD dwFreeSocketObjHold)		= 0;
	/* ڴ黺ػշֵͨΪڴ黺شС 3  */
	virtual void SetFreeBufferObjHold		(DWORD dwFreeBufferObjHold)		= 0;
	/* ù߳ͨΪ 2 * CPU + 2 */
	virtual void SetWorkerThreadCount		(DWORD dwWorkerThreadCount)		= 0;
	/* ùرǰȴӹرյʱޣ룬0 򲻵ȴ */
	virtual void SetMaxShutdownWaitTime		(DWORD dwMaxShutdownWaitTime)	= 0;
	/* ǷǾĬʱ䣨Ϊ TRUE ʱ DisconnectSilenceConnections()  GetSilencePeriod() ЧĬϣFALSE */
	virtual void SetMarkSilence				(BOOL bMarkSilence)				= 0;

	/* ȡݷͲ */
	virtual EnSendPolicy GetSendPolicy		()	= 0;
	/* ȡݷͲ */
	virtual EnRecvPolicy GetRecvPolicy		()	= 0;
	/* ȡ Socket ʱ */
	virtual DWORD GetFreeSocketObjLockTime	()	= 0;
	/* ȡ Socket شС */
	virtual DWORD GetFreeSocketObjPool		()	= 0;
	/* ȡڴ黺شС */
	virtual DWORD GetFreeBufferObjPool		()	= 0;
	/* ȡ Socket ػշֵ */
	virtual DWORD GetFreeSocketObjHold		()	= 0;
	/* ȡڴ黺ػշֵ */
	virtual DWORD GetFreeBufferObjHold		()	= 0;
	/* ȡ߳ */
	virtual DWORD GetWorkerThreadCount		()	= 0;
	/* ȡر齨ǰȴӹرյʱ */
	virtual DWORD GetMaxShutdownWaitTime	()	= 0;
	/* ǷǾĬʱ */
	virtual BOOL IsMarkSilence				()	= 0;

public:
	virtual ~IComplexSocket() {}
};

/************************************************************************
ƣͨŷӿ
ͨŷвԷʷ
************************************************************************/
class IServer : public IComplexSocket
{
public:

	/***********************************************************************/
	/*****************************  *****************************/

	/*
	* ƣͨ
	* ͨɺɿʼտͻӲշ
	*		
	* 		pszBindAddress	-- ַ
	*			usPort			-- ˿
	* ֵ	TRUE	-- ɹ
	*			FALSE	-- ʧܣͨ GetLastError() ȡ
	*/
	virtual BOOL Start	(LPCTSTR pszBindAddress, USHORT usPort)								= 0;

public:

	/***********************************************************************/
	/***************************** Էʷ *****************************/

	/* ȡ Socket ĵַϢ */
	virtual BOOL GetListenAddress(TCHAR lpszAddress[], int& iAddressLen, USHORT& usPort)	= 0;
};

/************************************************************************
ƣTCP ͨŷӿ
 TCP ͨŷвԷʷ
************************************************************************/
class ITcpServer : public IServer
{
public:

	/***********************************************************************/
	/*****************************  *****************************/

	/*
	* ƣСļ
	* ָӷ 4096 KB µСļ
	*		
	* 		dwConnID		--  ID
	*			lpszFileName	-- ļ·
	*			pHead			-- ͷ
	*			pTail			-- β
	* ֵ	TRUE	-- ɹ
	*			FALSE	-- ʧܣͨ Windows API  ::GetLastError() ȡ Windows 
	*/
	virtual BOOL SendSmallFile	(CONNID dwConnID, LPCTSTR lpszFileName, const LPWSABUF pHead = nullptr, const LPWSABUF pTail = nullptr)	= 0;

public:

	/***********************************************************************/
	/***************************** Էʷ *****************************/

	/*  Accept ԤͶݸصãAccept ԤͶԽֵ֧ĲԽࣩ */
	virtual void SetAcceptSocketCount	(DWORD dwAcceptSocketCount)		= 0;
	/* ͨݻСƽͨݰСãͨΪ 1024 ı */
	virtual void SetSocketBufferSize	(DWORD dwSocketBufferSize)		= 0;
	/* ü Socket ĵȺдСݲã */
	virtual void SetSocketListenQueue	(DWORD dwSocketListenQueue)		= 0;
	/* 룬0 򲻷 */
	virtual void SetKeepAliveTime		(DWORD dwKeepAliveTime)			= 0;
	/* ȷϰ룬0 ɴ [ĬϣWinXP 5 , Win7 10 ] ⲻȷϰΪѶߣ */
	virtual void SetKeepAliveInterval	(DWORD dwKeepAliveInterval)		= 0;

	/* ȡ Accept ԤͶ */
	virtual DWORD GetAcceptSocketCount	()	= 0;
	/* ȡͨݻС */
	virtual DWORD GetSocketBufferSize	()	= 0;
	/* ȡ Socket ĵȺдС */
	virtual DWORD GetSocketListenQueue	()	= 0;
	/* ȡ */
	virtual DWORD GetKeepAliveTime		()	= 0;
	/* ȡ */
	virtual DWORD GetKeepAliveInterval	()	= 0;
};

/************************************************************************
ƣUDP ͨŷӿ
 UDP ͨŷвԷʷ
************************************************************************/
class IUdpServer : public IServer
{
public:

	/***********************************************************************/
	/*****************************  *****************************/

public:

	/***********************************************************************/
	/***************************** Էʷ *****************************/

	/* ݱ󳤶ȣھ² 1472 ֽڣڹ² 548 ֽڣ */
	virtual void SetMaxDatagramSize		(DWORD dwMaxDatagramSize)	= 0;
	/* ȡݱ󳤶 */
	virtual DWORD GetMaxDatagramSize	()							= 0;

	/*  Receive ԤͶݸصãReceive ԤͶԽ򶪰ԽС */
	virtual void SetPostReceiveCount	(DWORD dwPostReceiveCount)	= 0;
	/* ȡ Receive ԤͶ */
	virtual DWORD GetPostReceiveCount	()							= 0;

	/* üԴ0 򲻷ͼԴΪѶߣ */
	virtual void SetDetectAttempts		(DWORD dwDetectAttempts)	= 0;
	/* üͼ룬0 ͼ */
	virtual void SetDetectInterval		(DWORD dwDetectInterval)	= 0;
	/* ȡ */
	virtual DWORD GetDetectAttempts		()							= 0;
	/* ȡ */
	virtual DWORD GetDetectInterval		()							= 0;
};

/************************************************************************
ƣͨŴӿ
ͨŴвԷʷһͬʱӶĿͻ
************************************************************************/
class IAgent : public IComplexSocket
{
public:

	/***********************************************************************/
	/*****************************  *****************************/

	/*
	* ƣͨ
	* ͨŴɺɿʼԶ̷
	*		
	* 		pszBindAddress	-- ַ
	*			bAsyncConnect	-- Ƿ첽 Connect
	* ֵ	TRUE	-- ɹ
	*			FALSE	-- ʧܣͨ GetLastError() ȡ
	*/
	virtual BOOL Start	(LPCTSTR pszBindAddress = nullptr, BOOL bAsyncConnect = TRUE)						= 0;

	/*
	* ƣӷ
	* ӷӳɹ IAgentListener յ OnConnect() ¼
	*		
	* 		pszRemoteAddress	-- ˵ַ
	*			usPort				-- ˶˿
	*			pdwConnID			--  IDĬϣnullptrȡ ID
	* ֵ	TRUE	-- ɹ
	*			FALSE	-- ʧܣͨ Windows API  ::GetLastError() ȡ Windows 
	*/
	virtual BOOL Connect(LPCTSTR pszRemoteAddress, USHORT usPort, CONNID* pdwConnID = nullptr)				= 0;

public:

	/***********************************************************************/
	/***************************** Էʷ *****************************/

	/* ȡĳӵıصַϢ */
	virtual BOOL GetLocalAddress(CONNID dwConnID, TCHAR lpszAddress[], int& iAddressLen, USHORT& usPort)	= 0;
};

/************************************************************************
ƣTCP ͨŴӿ
 TCP ͨŴвԷʷ
************************************************************************/
class ITcpAgent : public IAgent
{
public:

	/***********************************************************************/
	/*****************************  *****************************/

	/*
	* ƣСļ
	* ָӷ 4096 KB µСļ
	*		
	* 		dwConnID		--  ID
	*			lpszFileName	-- ļ·
	*			pHead			-- ͷ
	*			pTail			-- β
	* ֵ	TRUE	-- ɹ
	*			FALSE	-- ʧܣͨ Windows API  ::GetLastError() ȡ Windows 
	*/
	virtual BOOL SendSmallFile	(CONNID dwConnID, LPCTSTR lpszFileName, const LPWSABUF pHead = nullptr, const LPWSABUF pTail = nullptr)	= 0;

public:

	/***********************************************************************/
	/***************************** Էʷ *****************************/

	/* ǷõַûƣĬϣã */
	virtual void SetReuseAddress		(BOOL bReuseAddress)			= 0;
	/* Ƿõַû */
	virtual BOOL IsReuseAddress			()								= 0;

	/* ͨݻСƽͨݰСãͨΪ 1024 ı */
	virtual void SetSocketBufferSize	(DWORD dwSocketBufferSize)		= 0;
	/* 룬0 򲻷 */
	virtual void SetKeepAliveTime		(DWORD dwKeepAliveTime)			= 0;
	/* ȷϰ룬0 ɴ [ĬϣWinXP 5 , Win7 10 ] ⲻȷϰΪѶߣ */
	virtual void SetKeepAliveInterval	(DWORD dwKeepAliveInterval)		= 0;

	/* ȡͨݻС */
	virtual DWORD GetSocketBufferSize	()	= 0;
	/* ȡ */
	virtual DWORD GetKeepAliveTime		()	= 0;
	/* ȡ */
	virtual DWORD GetKeepAliveInterval	()	= 0;
};

/************************************************************************
ƣͨſͻӿ
ͨſͻвԷʷ
************************************************************************/
class IClient
{
public:

	/***********************************************************************/
	/*****************************  *****************************/

	/*
	* ƣͨ
	* ͻͨӷˣɺɿʼշ
	*		
	* 		pszRemoteAddress	-- ˵ַ
	*			usPort				-- ˶˿
	*			bAsyncConnect		-- Ƿ첽 Connect
	* ֵ	TRUE	-- ɹ
	*			FALSE	-- ʧܣͨ GetLastError() ȡ
	*/
	virtual BOOL Start	(LPCTSTR pszRemoteAddress, USHORT usPort, BOOL bAsyncConnect = FALSE)	= 0;

	/*
	* ƣرͨ
	* رտͻͨرɺϿ˵ӲͷԴ
	*		
	* 	
	* ֵ	TRUE	-- ɹ
	*			FALSE	-- ʧܣͨ GetLastError() ȡ
	*/
	virtual BOOL Stop	()																		= 0;

	/*
	* ƣ
	* ˷
	*		
	* 		pBuffer		-- ͻ
	*			iLength		-- ͻ
	*			iOffset		-- ͻָƫ
	* ֵ	TRUE	-- ɹ
	*			FALSE	-- ʧܣͨ Windows API  ::GetLastError() ȡ Windows 
	*/
	virtual BOOL Send	(const BYTE* pBuffer, int iLength, int iOffset = 0)						= 0;

	/*
	* ƣͶ
	* ˷Ͷ
	*		TCP - ˳ݰ 
	*		UDP - ݰϳһݰͣݰܳȲܴõ UDP 󳤶ȣ 
	*		
	* 		pBuffers	-- ͻ
	*			iCount		-- ͻĿ
	* ֵ	TRUE	-- ɹ
	*			FALSE	-- ʧܣͨ Windows API  ::GetLastError() ȡ Windows 
	*/
	virtual BOOL SendPackets(const WSABUF pBuffers[], int iCount)								= 0;

public:

	/***********************************************************************/
	/***************************** Էʷ *****************************/

	/* ӵĸ */
	virtual void SetExtra					(PVOID pExtra)										= 0;

	/* ȡӵĸ */
	virtual PVOID GetExtra					()													= 0;

	/* ͨǷ */
	virtual BOOL HasStarted					()													= 0;
	/* 鿴ͨǰ״̬ */
	virtual EnServiceState	GetState		()													= 0;
	/* ȡһʧܲĴ */
	virtual EnSocketError	GetLastError	()													= 0;
	/* ȡһʧܲĴ */
	virtual LPCTSTR			GetLastErrorDesc()													= 0;
	/* ȡ ID */
	virtual CONNID			GetConnectionID	()													= 0;
	/* ȡ Client Socket ĵַϢ */
	virtual BOOL		GetLocalAddress	(TCHAR lpszAddress[], int& iAddressLen, USHORT& usPort)	= 0;
	/* ȡδݵĳ */
	virtual BOOL GetPendingDataLength	(int& iPending)											= 0;

	/* ڴ黺شСͨΪ -> PUSH ģͣ5 - 10PULL ģͣ10 - 20  */
	virtual void SetFreeBufferPoolSize		(DWORD dwFreeBufferPoolSize)						= 0;
	/* ڴ黺ػշֵͨΪڴ黺شС 3  */
	virtual void SetFreeBufferPoolHold		(DWORD dwFreeBufferPoolHold)						= 0;

	/* ȡڴ黺شС */
	virtual DWORD GetFreeBufferPoolSize		()													= 0;
	/* ȡڴ黺ػշֵ */
	virtual DWORD GetFreeBufferPoolHold		()													= 0;

public:
	virtual ~IClient() {}
};

/************************************************************************
ƣTCP ͨſͻӿ
 TCP ͨſͻвԷʷ
************************************************************************/
class ITcpClient : public IClient
{
public:

	/***********************************************************************/
	/*****************************  *****************************/

	/*
	* ƣСļ
	* ˷ 4096 KB µСļ
	*		
	* 		lpszFileName	-- ļ·
	*			pHead			-- ͷ
	*			pTail			-- β
	* ֵ	TRUE	-- ɹ
	*			FALSE	-- ʧܣͨ Windows API  ::GetLastError() ȡ Windows 
	*/
	virtual BOOL SendSmallFile	(LPCTSTR lpszFileName, const LPWSABUF pHead = nullptr, const LPWSABUF pTail = nullptr)	= 0;

public:

	/***********************************************************************/
	/***************************** Էʷ *****************************/
	
	/* ͨݻСƽͨݰСãͨΪ(N * 1024) - sizeof(TBufferObj) */
	virtual void SetSocketBufferSize	(DWORD dwSocketBufferSize)	= 0;
	/* 룬0 򲻷 */
	virtual void SetKeepAliveTime		(DWORD dwKeepAliveTime)		= 0;
	/* ȷϰ룬0 ɴ [ĬϣWinXP 5 , Win7 10 ] ⲻȷϰΪѶߣ */
	virtual void SetKeepAliveInterval	(DWORD dwKeepAliveInterval)	= 0;

	/* ȡͨݻС */
	virtual DWORD GetSocketBufferSize	()	= 0;
	/* ȡ */
	virtual DWORD GetKeepAliveTime		()	= 0;
	/* ȡ */
	virtual DWORD GetKeepAliveInterval	()	= 0;
};

/************************************************************************
ƣUDP ͨſͻӿ
 UDP ͨſͻвԷʷ
************************************************************************/
class IUdpClient : public IClient
{
public:

	/***********************************************************************/
	/*****************************  *****************************/

public:

	/***********************************************************************/
	/***************************** Էʷ *****************************/

	/* ݱ󳤶ȣھ² 1472 ֽڣڹ² 548 ֽڣ */
	virtual void SetMaxDatagramSize	(DWORD dwMaxDatagramSize)	= 0;
	/* ȡݱ󳤶 */
	virtual DWORD GetMaxDatagramSize()							= 0;

	/* üԴ0 򲻷ͼԴΪѶߣ */
	virtual void SetDetectAttempts	(DWORD dwDetectAttempts)	= 0;
	/* üͼ룬0 ͼ */
	virtual void SetDetectInterval	(DWORD dwDetectInterval)	= 0;
	/* ȡ */
	virtual DWORD GetDetectAttempts	()							= 0;
	/* ȡ */
	virtual DWORD GetDetectInterval	()							= 0;
};

/************************************************************************
ƣUDP ӿ
 UDP 鲥㲥вԷʷ
************************************************************************/
class IUdpCast : public IClient
{
public:

	/***********************************************************************/
	/*****************************  *****************************/

public:

	/***********************************************************************/
	/***************************** Էʷ *****************************/

	/* ð󶨵ַ */
	virtual void SetBindAdddress	(LPCTSTR pszBindAddress)		= 0;
	/* ȡ󶨵ַ */
	virtual LPCTSTR GetBindAdddress	()								= 0;

	/* ݱ󳤶ȣھ² 1472 ֽڣڹ² 548 ֽڣ */
	virtual void SetMaxDatagramSize	(DWORD dwMaxDatagramSize)		= 0;
	/* ȡݱ󳤶 */
	virtual DWORD GetMaxDatagramSize()								= 0;

	/* ǷõַûƣĬϣã */
	virtual void SetReuseAddress	(BOOL bReuseAddress)			= 0;
	/* Ƿõַû */
	virtual BOOL IsReuseAddress		()								= 0;

	/* ôģʽ鲥㲥 */
	virtual void SetCastMode		(EnCastMode enCastMode)			= 0;
	/* ȡģʽ */
	virtual EnCastMode GetCastMode	()								= 0;

	/* 鲥ĵ TTL0 - 255 */
	virtual void SetMultiCastTtl	(int iMCTtl)					= 0;
	/* ȡ鲥ĵ TTL */
	virtual int GetMultiCastTtl		()								= 0;

	/* Ƿ鲥·TRUE or FALSE */
	virtual void SetMultiCastLoop	(BOOL bMCLoop)					= 0;
	/* Ƿ鲥· */
	virtual BOOL IsMultiCastLoop	()								= 0;

	/* ȡǰݱԶ̵ַϢͨ OnReceive ¼еã */
	virtual BOOL GetRemoteAddress	(TCHAR lpszAddress[], int& iAddressLen, USHORT& usPort)	= 0;
};

/************************************************************************
ƣServer/Agent PULL ģӿ
 Server/Agent  PULL ģв
************************************************************************/
class IPullSocket
{
public:

	/*
	* ƣץȡ
	* ûͨ÷ Socket ץȡ
	*		
	* 		dwConnID	--  ID
	*			pData		-- ץȡ
	*			iLength		-- ץȡݳ
	* ֵ	EnFetchResult
	*/
	virtual EnFetchResult Fetch	(CONNID dwConnID, BYTE* pData, int iLength)	= 0;

	/*
	* ƣ̽ݣƳݣ
	* ûͨ÷ Socket п̽
	*		
	* 		dwConnID	--  ID
	*			pData		-- ̽
	*			iLength		-- ̽ݳ
	* ֵ	EnFetchResult
	*/
	virtual EnFetchResult Peek	(CONNID dwConnID, BYTE* pData, int iLength)	= 0;

public:
	virtual ~IPullSocket() {}
};

/************************************************************************
ƣClient PULL ģӿ
 Client  PULL ģв
************************************************************************/
class IPullClient
{
public:

	/*
	* ƣץȡ
	* ûͨ÷ Socket ץȡ
	*		
	* 		pData		-- ץȡ
	*			iLength		-- ץȡݳ
	* ֵ	EnFetchResult
	*/
	virtual EnFetchResult Fetch	(BYTE* pData, int iLength)	= 0;

	/*
	* ƣ̽ݣƳݣ
	* ûͨ÷ Socket п̽
	*		
	* 		pData		-- ̽
	*			iLength		-- ̽ݳ
	* ֵ	EnFetchResult
	*/
	virtual EnFetchResult Peek	(BYTE* pData, int iLength)	= 0;

public:
	virtual ~IPullClient() {}
};

/************************************************************************
ƣTCP Server PULL ģӿ
̳ ITcpServer  IPullSocket
************************************************************************/
class ITcpPullServer : public IPullSocket, public ITcpServer
{
public:
	/* IServer* תΪ IPullSocket* */
	inline static IPullSocket* ToPull(IServer* pServer)
	{
		return (IPullSocket*)((char*)pServer - sizeof(IPullSocket));
	}

	/* IPullSocket* תΪ ITcpServer* */
	inline static ITcpServer* ToServer(IPullSocket* pPullSocket)
	{
		return (ITcpServer*)((char*)pPullSocket + sizeof(IPullSocket));
	}
};

/************************************************************************
ƣTCP Agent PULL ģӿ
̳ ITcpAgent  IPullSocket
************************************************************************/
class ITcpPullAgent : public IPullSocket, public ITcpAgent
{
public:
	/* IAgent* תΪ IPullSocket* */
	inline static IPullSocket* ToPull(IAgent* pAgent)
	{
		return (IPullSocket*)((char*)pAgent - sizeof(IPullSocket));
	}

	/* IPullSocket* תΪ ITcpAgent* */
	inline static ITcpAgent* ToAgent(IPullSocket* pPullSocket)
	{
		return (ITcpAgent*)((char*)pPullSocket + sizeof(IPullSocket));
	}
};

/************************************************************************
ƣTCP Client PULL ģӿ
̳ ITcpClient  IPullClient
************************************************************************/
class ITcpPullClient : public IPullClient, public ITcpClient
{
public:
	/* IClient* תΪ IPullClient* */
	inline static IPullClient* ToPull(IClient* pClient)
	{
		return (IPullClient*)((char*)pClient - sizeof(IPullClient));
	}

	/* IPullClient* תΪ ITcpClient* */
	inline static ITcpClient* ToClient(IPullClient* pPullClient)
	{
		return (ITcpClient*)((char*)pPullClient + sizeof(IPullClient));
	}
};
